aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorShiyang Ruan <ruansy.fnst@fujitsu.com>2021-11-09 11:21:10 +0800
committerEryu Guan <guaneryu@gmail.com>2021-11-14 22:15:54 +0800
commit9f8f0e4d5ae00990bac05fbd69a882255bf7bf9f (patch)
tree1c99b7a4f99b500c5af0102081f5f9e418c5d656
parente268739e5e88613e87ea8a1bf7b509418b6d3737 (diff)
downloadxfstests-dev-9f8f0e4d5ae00990bac05fbd69a882255bf7bf9f.tar.gz
generic: add mmap CoW test for 'mixed' case
Check what happens if we MMAP CoW blocks 2-4 of a page's worth of blocks when the surrounding blocks vary between unwritten/regular/delalloc/hole. (MMAP version of generic/229,238) Signed-off-by: Shiyang Ruan <ruansy.fnst@fujitsu.com> Reviewed-by: Eryu Guan <guaneryu@gmail.com> Signed-off-by: Eryu Guan <guaneryu@gmail.com>
-rwxr-xr-xtests/generic/655132
-rw-r--r--tests/generic/655.out62
2 files changed, 194 insertions, 0 deletions
diff --git a/tests/generic/655 b/tests/generic/655
new file mode 100755
index 0000000000..ec8366e3a1
--- /dev/null
+++ b/tests/generic/655
@@ -0,0 +1,132 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# FS QA Test No. 655
+#
+# See what happens if we MMAP CoW blocks 2-4 of a page's worth of blocks when
+# the surrounding blocks vary between unwritten/regular/delalloc/hole.
+# (MMAP version of generic/229,238)
+#
+# This test is dependent on the system page size, so we cannot use md5 in
+# the golden output; we can only compare to a check file.
+#
+. ./common/preamble
+_begin_fstest auto quick clone
+
+# Import common functions.
+. ./common/filter
+. ./common/reflink
+
+# real QA test starts here
+_require_scratch_reflink
+_require_xfs_io_command "falloc"
+
+pagesz=$(getconf PAGE_SIZE)
+blksz=$((pagesz / 4))
+
+echo "Format and mount"
+_scratch_mkfs_blocksized $blksz > $seqres.full 2>&1
+_scratch_mount >> $seqres.full 2>&1
+
+testdir=$SCRATCH_MNT/test-$seq
+mkdir $testdir
+
+real_blksz=$(_get_file_block_size $testdir)
+test $real_blksz != $blksz && _notrun "Failed to format with small blocksize."
+
+runtest() {
+ echo "runtest $1 $2"
+ b2=$1
+ b4=$2
+ dir=$3
+
+ echo "Create the original files"
+ mkdir -p $dir
+ _pwrite_byte 0x61 0 $pagesz $dir/file1 >> $seqres.full
+
+ $XFS_IO_PROG -f -c "truncate $pagesz" $dir/file2 >> $seqres.full
+ $XFS_IO_PROG -f -c "truncate $pagesz" $dir/file2.chk >> $seqres.full
+
+ case $b2 in
+ "regular")
+ _pwrite_byte 0x61 $blksz $blksz $dir/file2 >> $seqres.full
+ _pwrite_byte 0x61 $blksz $blksz $dir/file2.chk >> $seqres.full
+ ;;
+ "unwritten")
+ $XFS_IO_PROG -f -c "falloc -k $blksz $blksz" $dir/file2 >> $seqres.full
+ _pwrite_byte 0x00 $blksz $blksz $dir/file2.chk >> $seqres.full
+ ;;
+ "hole")
+ ;;
+ esac
+
+ case $b4 in
+ "regular")
+ _pwrite_byte 0x61 $((blksz * 3)) $blksz $dir/file2 >> $seqres.full
+ _pwrite_byte 0x61 $((blksz * 3)) $blksz $dir/file2.chk >> $seqres.full
+ ;;
+ "unwritten")
+ $XFS_IO_PROG -f -c "falloc -k $((blksz * 3)) $blksz" $dir/file2 >> $seqres.full
+ _pwrite_byte 0x00 $((blksz * 3)) $blksz $dir/file2.chk >> $seqres.full
+ ;;
+ "hole")
+ ;;
+ esac
+
+ _reflink_range $dir/file1 $blksz $dir/file2 $((blksz * 2)) $blksz >> $seqres.full
+ _pwrite_byte 0x61 $((blksz * 2)) $blksz $dir/file2.chk >> $seqres.full
+ _scratch_cycle_mount
+
+ echo "Compare files"
+ cmp -s $dir/file1 $dir/file2 && echo "file1 and file2 should not match."
+ cmp -s $dir/file2 $dir/file2.chk || echo "file2 and file2.chk don't match."
+
+ echo "CoW and unmount"
+ if [ $b2 = "delalloc" ]; then
+ _pwrite_byte 0x61 $blksz $blksz $dir/file2 >> $seqres.full
+ _pwrite_byte 0x61 $blksz $blksz $dir/file2.chk >> $seqres.full
+
+ # make sure we actually got delalloc block
+ $FILEFRAG_PROG -v $dir/file2 2>&1 | grep -q delalloc || \
+ _notrun "test requires delayed allocation writes"
+ fi
+
+ if [ $b4 = "delalloc" ]; then
+ _pwrite_byte 0x61 $((blksz * 3)) $blksz $dir/file2 >> $seqres.full
+ _pwrite_byte 0x61 $((blksz * 3)) $blksz $dir/file2.chk >> $seqres.full
+
+ # make sure we actually got delalloc block
+ $FILEFRAG_PROG -v $dir/file2 2>&1 | grep -q delalloc || \
+ _notrun "test requires delayed allocation writes"
+ fi
+
+ $XFS_IO_PROG -f -c "mmap 0 $pagesz" \
+ -c "pwrite -S 0x63 $((blksz + 17)) $((blksz * 3 - 34))" $dir/file2 >> $seqres.full
+ $XFS_IO_PROG -f -c "mmap 0 $pagesz" \
+ -c "pwrite -S 0x63 $((blksz + 17)) $((blksz * 3 - 34))" $dir/file2.chk >> $seqres.full
+ _scratch_cycle_mount
+
+ echo "Compare files"
+ cmp -s $dir/file1 $dir/file2 && echo "file1 and file2 should not match."
+ cmp -s $dir/file2 $dir/file2.chk || echo "file2 and file2.chk don't match."
+}
+
+runtest regular delalloc "$testdir/r-d"
+runtest regular unwritten "$testdir/r-u"
+runtest regular hole "$testdir/r-h"
+
+runtest hole delalloc "$testdir/h-d"
+runtest hole unwritten "$testdir/h-u"
+runtest hole regular "$testdir/h-r"
+
+runtest unwritten delalloc "$testdir/u-d"
+runtest unwritten hole "$testdir/u-h"
+runtest unwritten regular "$testdir/u-r"
+
+runtest delalloc unwritten "$testdir/d-u"
+runtest delalloc hole "$testdir/d-h"
+runtest delalloc regular "$testdir/d-r"
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/655.out b/tests/generic/655.out
new file mode 100644
index 0000000000..7c86df1a2f
--- /dev/null
+++ b/tests/generic/655.out
@@ -0,0 +1,62 @@
+QA output created by 655
+Format and mount
+runtest regular delalloc
+Create the original files
+Compare files
+CoW and unmount
+Compare files
+runtest regular unwritten
+Create the original files
+Compare files
+CoW and unmount
+Compare files
+runtest regular hole
+Create the original files
+Compare files
+CoW and unmount
+Compare files
+runtest hole delalloc
+Create the original files
+Compare files
+CoW and unmount
+Compare files
+runtest hole unwritten
+Create the original files
+Compare files
+CoW and unmount
+Compare files
+runtest hole regular
+Create the original files
+Compare files
+CoW and unmount
+Compare files
+runtest unwritten delalloc
+Create the original files
+Compare files
+CoW and unmount
+Compare files
+runtest unwritten hole
+Create the original files
+Compare files
+CoW and unmount
+Compare files
+runtest unwritten regular
+Create the original files
+Compare files
+CoW and unmount
+Compare files
+runtest delalloc unwritten
+Create the original files
+Compare files
+CoW and unmount
+Compare files
+runtest delalloc hole
+Create the original files
+Compare files
+CoW and unmount
+Compare files
+runtest delalloc regular
+Create the original files
+Compare files
+CoW and unmount
+Compare files